chiark / gitweb /
Merge tag dgit/2.14 into `defence in dgit-repos-server' branch
[dgit.git] / tests / tests / drs-push-rejects
index 7f088103adbf621c36e5dfab9e577063c7e69c49..dee14b86fe68f14cea98137ef22a03991471b046 100755 (executable)
@@ -5,42 +5,21 @@ set -e
 t-drs
 t-git-none
 
-p=pari-extra
+t-select-package pari-extra
 t-worktree drs
 
 cd $p
 
-reporefs () {
-       (set -e
-       if test -d $tmp/git/$p.git; then
-               cd $tmp/git/$p.git
-               git show-ref
-       fi)
-}
-
 mustfail () {
-       local wantmsg="$1"; shift
-       reporefs >$tmp/show-refs.pre-push
-       set +e
-       git push origin "$@" 2>&1 |tee $tmp/mustfail.txt
-       ps="${PIPESTATUS[*]}"
-       set -e
-       case $ps in
-       "0 0")  fail "push unexpectedly succeeded (instead of: $wantmsg)" ;;
-       *" 0")  ;;
-       *)      fail "tee failed"  ;;
-       esac
-       if ! fgrep "$wantmsg" $tmp/mustfail.txt >/dev/null; then
-               fail "error message not found"
-       fi
-       reporefs >$tmp/show-refs.post-push
-       diff $tmp/show-refs.{pre,post}-push
+       local mpat="$1"; shift
+       t-expect-push-fail "$mpat" \
+       git push origin "$@"
 }
 
 mustsucceed () {
-       reporefs >$tmp/show-refs.pre-push
+       t-reporefs pre-push
        git push origin "$@"
-       reporefs >$tmp/show-refs.post-push
+       t-reporefs post-push
        if diff $tmp/show-refs.{pre,post}-push >$tmp/show-refs.diff; then
                fail "no refs updated"
        fi
@@ -48,16 +27,20 @@ mustsucceed () {
 
 prep () {
        local suite=$1
-       local csuite=$2
+       csuite=$2
        cp $tmp/masters/* $tmp/.
        tag_signer='-u Senatus'
        tag_message="$p release $version for $suite ($csuite) [dgit]"
-       tag_name=debian/$version
+       re-prep
+}
+re-prep () {
+       tag_name=$tagpfx/$version
        push_spec1="HEAD:refs/dgit/$csuite"
        push_spec2="refs/tags/$tag_name"
        push_spec="$push_spec1 $push_spec2"
 }
 mktag () {
+       t-git-next-date
        git tag -f $tag_signer -m "$tag_message" $tag_name "$@"
 }
 
@@ -71,6 +54,39 @@ tag_signer='-a'
 mktag
 mustfail 'missing signature' $push_spec
 
+git cat-file tag $tag_name >goodtag
+
+for h in object type tag; do
+  for how in missing dupe; do
+
+    case $how in
+    missing) perl -pe 's/^tag /wombat$&/ if 1..m/^$/'  <goodtag >badtag ;;
+    dupe)   perl -pe 'print if 1..m/^$/ and m/^'$h' /' <goodtag >badtag ;;
+    esac
+
+    rm -f badtag.asc
+    gpg --detach-sign --armor -u Senatus badtag
+    cat badtag.asc >>badtag
+
+    set +e
+    LC_MESSAGES=C git hash-object -w -t tag badtag >badtag.hash 2>badtag.err
+    rc=$?
+    set -e
+
+    if [ $rc = 128 ] && grep 'fatal: corrupt tag' badtag.err; then
+      continue
+    elif [ $rc != 0 ]; then
+      cat badtag.err
+      fail "could not make tag"
+    fi
+
+    read <badtag.hash badtag
+    git update-ref refs/tags/$tag_name $badtag
+
+    mustfail 'multiple headers '$h' in signed tag object' $push_spec
+  done
+done
+
 prep unstable sid
 tag_message='something'
 mktag
@@ -86,10 +102,22 @@ mustfail 'sid != sponge' HEAD:refs/dgit/sponge $push_spec2
 prep unstable sid
 mktag
 mustfail 'push is missing tag ref update' $push_spec1
-mustfail 'push is missing head ref update' $push_spec2
+mustfail 'push is missing head ref update' +$push_spec2
 mustfail 'pushing unexpected ref' $push_spec HEAD:refs/wombat
 mustfail 'pushing multiple heads' $push_spec HEAD:refs/dgit/wombat
-mustfail 'pushing multiple tags' $push_spec HEAD:refs/tags/debian/wombat
+mustfail E:'pushing multiple tags|pushing too many similar tags' \
+       $push_spec HEAD:refs/tags/$tagpfx/wombat
+
+prep unstable sid
+mktag
+echo woody >$tmp/suites
+mustfail 'unknown suite' $push_spec
+cp $root/tests/suites $tmp/.
+
+# fixme:
+#    or reject "command string not understood";
+#    reject "unknown method" unless $mainfunc;
+
 
 prep unstable sid
 mktag
@@ -105,18 +133,41 @@ mktag HEAD~:
 mustfail 'tag refers to wrong kind of object' $push_spec
 
 prep unstable sid
-tag_name=debian/wombat
+tag_name=$tagpfx/wombat
 mktag
-#git update-ref debian/$version debian/wombat
+#git update-ref $tagpfx/$version $tagpfx/wombat
 mustfail 'tag name in tag is wrong' \
-       refs/tags/debian/wombat:refs/tags/debian/$version $push_spec1
+       refs/tags/$tagpfx/wombat:refs/tags/$tagpfx/$version $push_spec1
+
+echo ====
+badcommit=$(
+       git cat-file commit HEAD | \
+       perl -pe 's/^committer.*\n//' | \
+       git hash-object -w -t commit --stdin
+)
+git checkout -b broken $badcommit
+prep unstable sid
+mktag
+mustfail "corrupted object $badcommit" $push_spec
 
+git checkout dgit/sid
 prep unstable sid
 mktag
 mustsucceed $push_spec # succeeds
 
 mktag
-mustfail 'not replacing previously-pushed version' $push_spec
+mustfail 'push is missing head ref update' $push_spec1 +$push_spec2
+
+git commit --allow-empty -m 'Dummy update'
+mktag
+mustfail 'not replacing previously-pushed version' +$push_spec1 +$push_spec2
+
+t-newtag
+re-prep
+mktag
+mustfail 'not replacing previously-pushed version' +$push_spec1 +$push_spec2
+
+git reset --hard HEAD~
 
 prep_dm_mangle () {
        prep unstable sid
@@ -152,4 +203,7 @@ mustfail "not in permissions list although in keyring" $push_spec
 prep_dm_mangle ''
 mustsucceed $push_spec # succeeds
 
-echo ok.
+# we generate some junk, so we must tolerate git-fsck complaining
+expect_fsck_fail=true
+
+t-ok